<template>
  <template-page
    ref="pageRef"
    :get-list="getList"
    :export-list="exportList"
    :operation="operation()"
    :options-evens-group="optionsEvensGroup"
    :column-parsing="columnParsing"
  >
    <Popu v-if="visible">
      <DealerListDetail :details-id="detailsId" @close="handleClose" />
    </Popu>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import add_callback_mixin from '@/components/template/add_callback_mixin.js'
import Popu from '@/components/template/popu.vue'

import { getDealerListV2, exportDealerListV2, importCustomerV2, exportJiaXianV2 } from '@/api/basic_data/dealer'

import DealerListDetail from './components/dealer_list-detail.vue'
export default {
  components: { TemplatePage, Popu, DealerListDetail },
  mixins: [import_mixin, add_callback_mixin],
  data() {
    return {
      visible: false,
      // 事件组合
      optionsEvensGroup: [
        [
          [
            {
              name: '导入',
              render: this.importButton(importCustomerV2)
            }
          ]
        ],
        [
          [
            {
              name: '导出提贷物流存货类别',
              click: p => {
                const loading = this.$loading({
                  lock: true,
                  text: 'Loading',
                  spinner: 'el-icon-loading',
                  background: 'rgba(0, 0, 0, 0.7)'
                })
                exportJiaXianV2(
                  {
                    pageNum: 1,
                    pageSize: -1,
                    params: this.$refs.pageRef.getParams().querylist
                  },
                  `${this.$route.meta.title}`
                )
                  .then(_res => {
                    this.$message({
                      message: '导出成功',
                      type: 'success'
                    })
                  })
                  .catch(_err => {})
                  .finally(() => loading.close())
              }
            }
          ]
        ]
      ],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: true
      }, // 关闭新增弹窗

      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      recordSelected: [],

      detailsId: ''
    }
  },
  methods: {
    // 列表请求函数
    getList(...p) {
      this.recordSelected = []
      return getDealerListV2(...p)
    },
    // 列表导出函数
    exportList: exportDealerListV2,
    // 表格列解析渲染数据更改
    columnParsing(_item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    operation() {
      return (_h, { row, index, column }) => {
        return (
          <div class="operation-btns">
            <el-button
              size="mini"
              type="text"
              onClick={() => {
                this.visible = true
                this.detailsId = row.id
              }}
            >
              查看
            </el-button>
          </div>
        )
      }
    },
    handleClose() {
      this.addOff(() => {
        this.visible = false
      })()
    }
  }
}
</script>

<style lang="scss" scoped></style>
